//Do not edit! This file was generated by Unity-ROS MessageGeneration.
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Unity.Robotics.ROSTCPConnector.MessageGeneration;
using RosMessageTypes.BuiltinInterfaces;

namespace RosMessageTypes.Server
{
    [Serializable]
    public class GazetargetGoal : Message
    {
        public const string k_RosMessageName = "hlrc_server/gazetargetGoal";
        public override string RosMessageName => k_RosMessageName;

        // pan  angle (left/right)
        public float pan;
        // tilt angle (up/down)
        public float tilt;
        // roll angle (sideway movement)
        public float roll;
        // vergence angle (angle difference from straight view, defaults to 0.0 for straight)
        public float vergence;
        // offsets
        public float pan_offset;
        public float tilt_offset;
        // relative or absolute gaze target?
        public const byte GAZETARGET_ABSOLUTE = 0;
        public const byte GAZETARGET_RELATIVE = 1;
        public byte gaze_type;
        // timestamp of the target (important in case of relative targets)
        public TimeMsg gaze_timestamp;

        public GazetargetGoal()
        {
            this.pan = 0.0f;
            this.tilt = 0.0f;
            this.roll = 0.0f;
            this.vergence = 0.0f;
            this.pan_offset = 0.0f;
            this.tilt_offset = 0.0f;
            this.gaze_type = 0;
            this.gaze_timestamp = new TimeMsg();
        }

        public GazetargetGoal(float pan, float tilt, float roll, float vergence, float pan_offset, float tilt_offset, byte gaze_type, TimeMsg gaze_timestamp)
        {
            this.pan = pan;
            this.tilt = tilt;
            this.roll = roll;
            this.vergence = vergence;
            this.pan_offset = pan_offset;
            this.tilt_offset = tilt_offset;
            this.gaze_type = gaze_type;
            this.gaze_timestamp = gaze_timestamp;
        }

        public static GazetargetGoal Deserialize(MessageDeserializer deserializer) => new GazetargetGoal(deserializer);

        private GazetargetGoal(MessageDeserializer deserializer)
        {
            deserializer.Read(out this.pan);
            deserializer.Read(out this.tilt);
            deserializer.Read(out this.roll);
            deserializer.Read(out this.vergence);
            deserializer.Read(out this.pan_offset);
            deserializer.Read(out this.tilt_offset);
            deserializer.Read(out this.gaze_type);
            this.gaze_timestamp = TimeMsg.Deserialize(deserializer);
        }

        public override void SerializeTo(MessageSerializer serializer)
        {
            serializer.Write(this.pan);
            serializer.Write(this.tilt);
            serializer.Write(this.roll);
            serializer.Write(this.vergence);
            serializer.Write(this.pan_offset);
            serializer.Write(this.tilt_offset);
            serializer.Write(this.gaze_type);
            serializer.Write(this.gaze_timestamp);
        }

        public override string ToString()
        {
            return "GazetargetGoal: " +
            "\npan: " + pan.ToString() +
            "\ntilt: " + tilt.ToString() +
            "\nroll: " + roll.ToString() +
            "\nvergence: " + vergence.ToString() +
            "\npan_offset: " + pan_offset.ToString() +
            "\ntilt_offset: " + tilt_offset.ToString() +
            "\ngaze_type: " + gaze_type.ToString() +
            "\ngaze_timestamp: " + gaze_timestamp.ToString();
        }

#if UNITY_EDITOR
        [UnityEditor.InitializeOnLoadMethod]
#else
        [UnityEngine.RuntimeInitializeOnLoadMethod]
#endif
        public static void Register()
        {
            MessageRegistry.Register(k_RosMessageName, Deserialize, MessageSubtopic.Goal);
        }
    }
}
